float fishSize = 80;
float fishX,fishY;
float fishSpeed=2;
float foodSize=10;
float foodX,foodY;
float percent;
boolean alive=true;
int eaten=0;
int maxFood=10;
float moveFish;
float spawnFood;
Ball[] balls;
PImage meinBild;
boolean start = true;
boolean spiel = false;
boolean regeln = false;
boolean game_over = false;
float speed = 1;
PVector mousePos;
Fish fish;
PVector pv;

void setup() {
  background(#6FB5F0);
  size(600,400);
  reset();
}

void redrawScreen() {        // ----- neue Methode zum Rücksetzen des Screens -----
  // clear screen
  background(#6FB5F0);
  // redraw balls
  for(Ball b : balls) {
    b.display();
  }
}


class Ball {
  PVector pos;
  PVector v;
  boolean eaten;
  boolean shark; // if shark is true, else false
  Ball(PVector pos, PVector v, boolean shark) {
    this.pos = pos;
    this.v = v;
    this.eaten = false;
    this.shark = shark;
  }
 
  void move() {
    this.pos.add(this.v);
   
    if (this.pos.x > 600) {
      //this.pos.x = 0;        // ----- Invertierung des Vektors bei Berühren der Wand -----
      this.v.x *= -1;
    }
    if (this.pos.y > 400) {
      //this.pos.y = 0;
      this.v.y *= -1;
    }
    if (this.pos.x < 0) {
      //this.pos.x = 600;
      this.v.x *= -1;
    }
    if (this.pos.y < 0) {      // ----- x korrigiert in y -----
      //this.pos.x = 400;
      this.v.y *= -1;
    }
  }
 
  void display() {
    fill(0,200,0);
    circle(this.pos.x, this.pos.y, foodSize);
  }
}


class Fish {
  PVector pos;
  PVector v;
  Fish(PVector pos) {
    this.pos = pos;
    this.v = new PVector(0, 0);
  }
 
  void move() {
    mousePos = new PVector(mouseX, mouseY);
    mousePos.sub(this.pos).setMag(fishSpeed);
    this.v = mousePos;
    this.pos.add(this.v);
   
    if (this.pos.x > 600) {
      this.pos.x = 0;
    }
    if (this.pos.y > 400) {
      this.pos.y = 0;
    }
    if (this.pos.x < 0) {
      this.pos.x = 600;
    }
    if (this.pos.x < 0) {
      this.pos.x = 400;
    }
  }
 
  void display() {
    fill(255,255,0);
    circle(this.pos.x,this.pos.y,fishSize);
  }
}

void reset() {
  fishX=width/2;
  fishY=height/2;
  balls = new Ball[maxFood];
  for (int i = 0; i < maxFood; i++) {
    PVector p = new PVector(random(600), random(400));
    PVector v = new PVector(random(-1, 1), random(-1, 1)).setMag(speed);
    balls[i] = new Ball(p, v, false);
  }
  fish = new Fish(new PVector(300, 200));
  mousePos = new PVector(0, 0);
}


void draw() {
  if (start) {
    start_screen();
    fill(#1C2176);
    textSize(50);
    text("Welcome to FISH DISH", 70,200);
    textSize(20);
    text("Press the mousebutton to DISH your FISH :)", 130, 230);
  }
 
 
 
  else if (spiel) {
    spiel();
  }
 
  else if (regeln) {

    regeln_screen();
  }
 
  else if (game_over) {
  game_over();
  }
}

void regeln_screen() {
  // draw smth and write rules
}


void start_screen() {
  // draw smth
  if (mousePressed) {
    start = false;
    spiel = true;
  }
}

void game_over() {
   textSize(50);
   fill(255);
   text("Game over!", width/2-100, height/2);
   if (mousePressed) {
     game_over = false;
     start = true;
   }
}


void spiel() {
 
  //Futter zeichnen
  for(Ball b : balls) {
    /*if (!b.eaten) {
      b.display();
      b.move();
    }*/
   
    if (b.eaten) {            // ----- gefressenen Ball durch neuen ersetzen -----
      PVector p = new PVector(random(600), random(400));
      PVector v = new PVector(random(-1, 1), random(-1, 1)).setMag(speed);
      b.pos = p;
      b.v = v;
      b.eaten = false;
    }
    else {
      b.move();
    }
  }
  redrawScreen();            // ----- Screen zurücksetzen & neu zeichnen -----
 
   
  // Fisch zeichnen
  if(alive) {
    fish.display();
    fish.move();
  } else {
    game_over = true;
    spiel = false;
  }
 
  //Prozentualen Anteil an gegessenen Futter berechnen
 
  percent = eaten+1;
  fill(0);
  textSize(20);
  text("Futter"+ percent + "%", width-110, 20);
 
  pv = fish.pos.copy();
  //Futter fressen
 for(Ball b : balls) {
   if (pv.dist(b.pos) < fishSize/2 && !b.eaten) {      // ----- /2 hinzugefügt, damit Bälle schöner gefressen werden -----
     eaten++;
     b.eaten = true;
   }
 }
  if(percent == 100){
    fill(0);
    textSize(40);
    textAlign(CENTER);
    strokeWeight(2);
    text("You won!", 150,200);
    spiel=false;
    regeln=false;
   
  }
  circle(fish.pos.x+fishSize/2, fish.pos.y, 10);
  if(fish.pos.x+fishSize/2 >= width || fish.pos.x-fishSize/2 <=0 || fish.pos.y-fishSize/2 <= 0 || fish.pos.y+fishSize/2 >= height) {
   game_over=true;
   spiel=false;
   regeln=false;
  }
}
